package br.com.rhino.user.entity;

import java.time.LocalDateTime;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.PrePersist;
import javax.persistence.Table;

@Entity
@Table(name = "permission")
public class Permission {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    public Long id;
    public String name;
    public String description;
    @Column(name = "dt_creation")
    public LocalDateTime createdAt;

    @PrePersist
    public void prePersist() {
        final LocalDateTime now = LocalDateTime.now();
        createdAt = now;
    }

    public Permission id(final Long id) {
        this.id = id;
        return this;
    }

    public Permission name(final String name) {
        this.name = name;
        return this;
    }

    public Permission description(final String description) {
        this.description = description;
        return this;
    }
}
