package br.com.rhino.user.entity;

import java.time.LocalDateTime;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.PrePersist;
import javax.persistence.Table;

@Entity
@Table(name = "roles")
public class Role {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    public Long id;

    @Column(name = "role_name")
    public String roleName;

    @Column(name = "dt_creation")
    public LocalDateTime createdAt;

    @JoinTable(
            name = "roles_permission",
            joinColumns = @JoinColumn(name = "role_id"),
            inverseJoinColumns = @JoinColumn(name = "permission_id")
    )
    @OneToMany(cascade = CascadeType.MERGE, fetch = FetchType.EAGER)
    public Set<Permission> permissions;

    @PrePersist
    public void prePersist() {
        final LocalDateTime now = LocalDateTime.now();
        createdAt = now;
    }

    public Role id(final Long id) {
        this.id = id;
        return this;
    }

    public Role roleName(final String roleName) {
        this.roleName = roleName;
        return this;
    }

    public Role permissions(final Set<Permission> permissions) {
        this.permissions = permissions;
        return this;
    }
}
