create TABLE IF NOT EXISTS "user" (
 	id serial PRIMARY KEY  ,
	username VARCHAR ( 50 ) UNIQUE NOT NULL,
	password VARCHAR ( 50 ) NOT NULL,
	email VARCHAR ( 255 ) UNIQUE NOT NULL,
    dt_creation TIMESTAMP NOT NULL,
	dt_update TIMESTAMP NOT NULL
);

create TABLE IF NOT EXISTS roles (
   id serial PRIMARY KEY,
   role_name VARCHAR (255) UNIQUE NOT NULL,
   dt_creation TIMESTAMP NOT NULL
);

create TABLE IF NOT EXISTS permission (
   id serial PRIMARY KEY,
   "name" VARCHAR (155) UNIQUE NOT NULL,
   description VARCHAR (500) NOT NULL,
   dt_creation TIMESTAMP NOT NULL
);

create TABLE IF NOT EXISTS  roles_permission (
  permission_id INT NOT NULL,
  role_id INT NOT NULL,
  PRIMARY KEY (permission_id, role_id),
  FOREIGN KEY (role_id) REFERENCES roles (id),
  FOREIGN KEY (permission_id) REFERENCES permission (id)
);

create TABLE IF NOT EXISTS  user_roles (
  user_id INT NOT NULL,
  role_id INT NOT NULL,
  PRIMARY KEY (user_id, role_id),
  FOREIGN KEY (role_id) REFERENCES roles (id),
  FOREIGN KEY (user_id) REFERENCES user_account (id)
);

create TABLE IF NOT EXISTS address (
   id serial PRIMARY KEY,
   number VARCHAR (10) NOT NULL,
   street VARCHAR (400) NOT NULL,
   district VARCHAR (255) NOT NULL,
   zip_code VARCHAR (10) NOT NULL,
   city VARCHAR (255) NOT NULL,
   state VARCHAR (255) NOT NULL,
   dt_creation TIMESTAMP NOT NULL,
   dt_update TIMESTAMP NOT NULL
);

create TABLE IF NOT EXISTS person_company (
 	id serial PRIMARY KEY ,
 	address_id INT NOT NULL,
	name_company_name VARCHAR ( 50 ) UNIQUE NOT NULL,
	phone VARCHAR ( 11 ) NOT NULL,
	email VARCHAR ( 255 ) UNIQUE NOT NULL,
    dt_creation TIMESTAMP NOT NULL,
	dt_update TIMESTAMP NOT NULL,
	FOREIGN KEY (address_id) REFERENCES address (id)
);

create TABLE IF NOT EXISTS person (
 	id serial PRIMARY KEY ,
 	person_company_id INT NOT NULL,
    cpf VARCHAR (11) UNIQUE NOT NULL,
    dt_creation TIMESTAMP NOT NULL,
	dt_update TIMESTAMP NOT NULL,
	FOREIGN KEY (person_company_id) REFERENCES person_company (id)
);

create TABLE IF NOT EXISTS company (
 	id serial PRIMARY KEY ,
 	person_company_id INT NOT NULL,
    cnpj VARCHAR (14) UNIQUE NOT NULL,
    dt_creation TIMESTAMP NOT NULL,
	dt_update TIMESTAMP NOT NULL,
	FOREIGN KEY (person_company_id) REFERENCES person_company (id)
);